//1.插入大字段信息:
package java_jdbc;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
public class jdbc_operate_bigData{
    // 定义 DM JDBC 驱动串
    static String jdbcString = "dm.jdbc.driver.DmDriver";
    // 定义 DM URL 连接串
    static String urlString = "jdbc:dm://localhost:5236";
    // 定义连接用户名
    static String userName = "SYSDBA";
    // 定义连接用户口令
    static String password = "SYSDBA";
    // 定义连接对象
    static Connection conn = null;
    // 定义 SQL 语句执行对象
    static PreparedStatement pstate = null;
    public static void main(String[] args) {
        try {
            //1.加载 JDBC 驱动程序
            System.out.println("Loading JDBC Driver...");
            Class.forName(jdbcString);
            //2.连接 DM 数据库
            System.out.println("Connecting to DM Server...");
            conn = DriverManager.getConnection(urlString, userName, password);
//------------------------------------------------------------------------------------------------------------------------
            //1.插入大字段信息:
            String sql_insert = "INSERT INTO production.BIG_DATA (\"photo\","
                    + "\"describe\",\"txt\")VALUES(?,?,?);";
            pstate = conn.prepareStatement(sql_insert);
            //加载图片为输入流
            String filePath = "D:\\DM8特点.jpg";
            File file = new File(filePath);
            String filePath2 = "D:\\达梦产品简介.txt";
            File file2 = new File(filePath2);
            InputStream in = new BufferedInputStream(new FileInputStream(file));
            InputStream in2 = new BufferedInputStream(new FileInputStream(file));
            BufferedReader reader = new BufferedReader(
                    new InputStreamReader(new FileInputStream(file2),"UTF-8"));
            //1.绑定 stream 流信息到第一个?
            pstate.setBinaryStream(1, in);
            //2.绑定 Inputstream 对象到第二个?这里
            pstate.setBlob(2, in2);
            //3.绑定 Reader 对象到第三个?
            pstate.setClob(3, reader);
            pstate.executeUpdate();
            //------------------------------------------------------------------------------------------------------------------------
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        } finally {
            try {
                pstate.close();
                conn.close();
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }
}